"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var cookie_universal_1 = __importDefault(require("cookie-universal"));
var utils_1 = require("@src/shared/utils");
var api_1 = require("@src/api");
var defaultOptions = {
    isParsing: false
};
function useCookie(cookieName, options, runOnMount) {
    if (runOnMount === void 0) { runOnMount = true; }
    var _a = Object.assign({}, defaultOptions, options), isParsing = _a.isParsing, opts = __rest(_a, ["isParsing"]);
    var serializer = utils_1.createSerializer(opts.serializer);
    var deserializer = utils_1.createDeserializer(opts.deserializer);
    var cookieLib = cookie_universal_1.default(undefined, undefined, false);
    var cookie = api_1.ref(null);
    var getCookie = function () {
        var cookieVal = utils_1.tryDeserialize(cookieLib.get(cookieName), deserializer, isParsing);
        if (!utils_1.isNullOrUndefined(cookieVal))
            cookie.value = cookieVal;
    };
    var setCookie = function (
    // The user may pass a 'string', a 'number', a valid JSON object/array
    // or even a custom object when serializer/deserializer are defined
    // so it is better to set allowed cookie value as 'any'
    newVal, options) {
        var newCookieVal = utils_1.trySerialize(newVal, serializer, isParsing);
        cookieLib.set(cookieName, newCookieVal, options);
        cookie.value = utils_1.tryDeserialize(newCookieVal, deserializer, isParsing);
    };
    var removeCookie = function (options) {
        cookieLib.remove(cookieName, options);
        cookie.value = null;
    };
    api_1.onMounted(function () { return runOnMount && getCookie(); });
    return { cookie: cookie, getCookie: getCookie, setCookie: setCookie, removeCookie: removeCookie };
}
exports.useCookie = useCookie;
