"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var api_1 = require("@src/api");
function useIntervalFn(callback, ms, runOnMount) {
    if (ms === void 0) { ms = 0; }
    if (runOnMount === void 0) { runOnMount = true; }
    var isRunning = api_1.ref(false);
    var interval = null;
    var start = function () {
        if (interval)
            return;
        isRunning.value = true;
        interval = setInterval(callback, ms);
    };
    var stop = function () {
        clearInterval(interval);
        isRunning.value = false;
        interval = null;
    };
    api_1.onMounted(function () { return runOnMount && start(); });
    api_1.onUnmounted(stop);
    return { isRunning: isRunning, start: start, stop: stop };
}
exports.useIntervalFn = useIntervalFn;
