"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var createStorage_1 = require("@src/shared/createStorage");
var api_1 = require("@src/api");
function useLocalStorage(key, options, runOnMount) {
    if (runOnMount === void 0) { runOnMount = true; }
    var _a = createStorage_1.createStorage(localStorage, key, options), item = _a.item, getItem = _a.getItem, setItem = _a.setItem, removeItem = _a.removeItem;
    api_1.onMounted(function () { return runOnMount && getItem(); });
    return {
        item: item,
        getItem: getItem,
        setItem: setItem,
        removeItem: removeItem
    };
}
exports.useLocalStorage = useLocalStorage;
