"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var api_1 = require("@src/api");
function useMedia(query, defaultState) {
    if (defaultState === void 0) { defaultState = false; }
    var mql;
    var matches = api_1.ref(defaultState);
    var updateMatchValue = function () { return (matches.value = mql.matches); };
    api_1.onMounted(function () {
        mql = window.matchMedia(query);
        mql.addListener(updateMatchValue);
        updateMatchValue();
    });
    api_1.onUnmounted(function () {
        mql.removeListener(updateMatchValue);
    });
    return matches;
}
exports.useMedia = useMedia;
