"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var api_1 = require("@src/api");
function useMouseElement(elRef) {
    var docX = api_1.ref(0);
    var docY = api_1.ref(0);
    var elX = api_1.ref(0);
    var elY = api_1.ref(0);
    var elInfoX = api_1.ref(0);
    var elInfoY = api_1.ref(0);
    var elInfoW = api_1.ref(0);
    var elInfoH = api_1.ref(0);
    var mouseMoveHandler = function (e) {
        if (!elRef.value)
            return;
        docX.value = e.pageX;
        docY.value = e.pageY;
        var _a = elRef.value.getBoundingClientRect(), left = _a.left, top = _a.top, height = _a.height, width = _a.width;
        elInfoX.value = left + window.pageXOffset;
        elInfoY.value = top + window.pageYOffset;
        elInfoW.value = width;
        elInfoH.value = height;
        elX.value = e.pageX - elInfoX.value;
        elY.value = e.pageY - elInfoY.value;
    };
    api_1.onMounted(function () {
        document.addEventListener('mousemove', mouseMoveHandler);
    });
    api_1.onUnmounted(function () {
        document.removeEventListener('mousemove', mouseMoveHandler);
    });
    return {
        docX: docX,
        docY: docY,
        elX: elX,
        elY: elY,
        elInfoX: elInfoX,
        elInfoY: elInfoY,
        elInfoW: elInfoW,
        elInfoH: elInfoH
    };
}
exports.useMouseElement = useMouseElement;
