"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var api_1 = require("@src/api");
var useRafFn_1 = require("@src/functions/useRafFn");
var fpsLimit = 60;
function useRaf(fps, runOnMount) {
    if (fps === void 0) { fps = fpsLimit; }
    if (runOnMount === void 0) { runOnMount = true; }
    var elapsed = api_1.ref(0);
    var animHandler = function (elapsedTime) {
        elapsed.value = elapsedTime;
    };
    var _a = useRafFn_1.useRafFn(animHandler, fps, runOnMount), isRunning = _a.isRunning, start = _a.start, stop = _a.stop;
    return {
        isRunning: isRunning,
        elapsed: elapsed,
        start: start,
        stop: stop
    };
}
exports.useRaf = useRaf;
