"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var api_1 = require("@src/api");
function useScroll(elRef, ms, runOnMount) {
    if (ms === void 0) { ms = 150; }
    if (runOnMount === void 0) { runOnMount = true; }
    var isTracking = api_1.ref(false);
    var isScrolling = api_1.ref(false);
    var x = api_1.ref(0);
    var y = api_1.ref(0);
    var scrollingTimeout = null;
    var updateScrollStatus = function () {
        isScrolling.value = true;
        clearTimeout(scrollingTimeout);
        scrollingTimeout = setTimeout(function () { return (isScrolling.value = false); }, ms);
    };
    var updateWindowElement = function () {
        x.value = window.pageXOffset;
        y.value = window.pageYOffset;
    };
    var updateHTMLElement = function () {
        x.value = elRef.value.scrollLeft;
        y.value = elRef.value.scrollTop;
    };
    var updateElScrollPos = function () {
        if (!elRef.value)
            return;
        elRef.value === window ? updateWindowElement() : updateHTMLElement();
    };
    var handleScroll = function () {
        updateElScrollPos();
        updateScrollStatus();
    };
    var start = function () {
        if (isTracking.value)
            return;
        if (elRef.value) {
            elRef.value.addEventListener('scroll', handleScroll, {
                capture: false,
                passive: true
            });
            updateElScrollPos();
        }
        isTracking.value = true;
    };
    var stop = function () {
        if (!isTracking.value)
            return;
        if (elRef.value)
            elRef.value.removeEventListener('scroll', handleScroll);
        isTracking.value = false;
    };
    api_1.onMounted(function () { return runOnMount && start(); });
    api_1.onUnmounted(stop);
    return { x: x, y: y, isTracking: isTracking, isScrolling: isScrolling, start: start, stop: stop };
}
exports.useScroll = useScroll;
