import { CookieSerializeOptions } from 'cookie';
import { SerializerFunction, DeserializerFunction } from "../../shared/utils";
import { Ref } from "../../api";
export interface UseCookieOptions {
    isParsing: boolean;
    serializer?: SerializerFunction;
    deserializer?: DeserializerFunction;
}
export declare function useCookie(cookieName: string, options?: UseCookieOptions, runOnMount?: boolean): {
    cookie: Ref<any>;
    getCookie: () => void;
    setCookie: (newVal: any, options?: CookieSerializeOptions | undefined) => void;
    removeCookie: (options?: CookieSerializeOptions | undefined) => void;
};
