import { Ref } from "../../api";
export interface UseGeolocation {
    loading: boolean;
    accuracy: number | null;
    altitude: number | null;
    altitudeAccuracy: number | null;
    heading: number | null;
    latitude: number | null;
    longitude: number | null;
    speed: number | null;
    timestamp: number | null;
    error?: Error | PositionError;
}
export declare function useGeolocation(options?: PositionOptions, runOnMount?: boolean): {
    isTracking: Ref<boolean>;
    geo: Ref<UseGeolocation>;
    start: () => void;
    stop: () => void;
};
